<!-- How do I use the BEC (client)? -->
(user)=
# User
**Introduction**

Welcome to the User section of the BEC documentation! BEC is an experiment control system mostly based on Python that equips users with a command-line interface (CLI) and a graphical user interface (GUI) for controlling devices and executing scans. This section provides essential information for users exploring BEC, regardless of their level of familiarity.

**Key Topics**

* [Installing the BEC client](#user.installation): Set up a local BEC client on your machine to interact with an already deployed BEC system.
* [Devices](#user.devices): Learn how to access, configure and update device settings.
* [Command-Line Interface (CLI)](#user.command_line_interface): Interact with BEC through the CLI, including device access, motor control, and scan execution. Learn how to use the scan interface and write your own scripts and macros. 
* [Graphical User Interface (GUI)](#user.graphical_user_interface): Learn how to utilize the modular widgets and functionalities of the GUI.
* [Data Access and Plotting](#user.data_access_and_plotting): Examining and plotting scan data for live feedback and online data analysis.


For detailed insights into BEC's underlying architecture, customization possibilities, or extensions to deployed systems at the beamline, please explore the [Developer](#developer) section. Enjoy exploring and experimenting with BEC!

```{important}
If you have any questions or feature requests, please feel free to open an issue on the [GitLab](https://gitlab.psi.ch/bec/bec/-/issues?sort=created_date&state=opened). We are happy to help you with any questions you might have.
```

```{toctree}
---
maxdepth: 1
hidden: true
---

installation
devices
command_line_interface
graphical_user_interface
data_access_and_plotting
